import { world } from "@minecraft/server";
import { showDamage, recalculateDamage, setAngleAnimation } from "./entityEvents";

world.afterEvents.entityHurt.subscribe((event) => {
    const attacker = event.damageSource.damagingEntity;
    const hurtEntity = event.hurtEntity;

    if (hurtEntity?.typeId === "target_dummy:target_dummy_entity") {
        let damageAmount = 0;
        if (attacker?.typeId === "minecraft:player") {
            const itemUsed = attacker.getComponent("equippable")?.getEquipment("Mainhand");
            damageAmount = recalculateDamage(itemUsed, event.damage);
        } else {
            damageAmount = event.damage;
        }
        setAngleAnimation(hurtEntity, attacker);
        showDamage(hurtEntity, damageAmount);
    }
});

world.afterEvents.projectileHitEntity.subscribe((event) => {
    const shooterEntity = event.source;
    const entityHit = event.getEntityHit().entity;
    const projectile = event.projectile;
    
    if (entityHit?.typeId === "target_dummy:target_dummy_entity" && projectile?.typeId.includes("arrow")) {
        shooterEntity.playSound("mob.player.bow_ding");
    }
});